%global meadalpha %{nil}
%global meadrel %{nil}
%global version_major 2
%global version_minor 0
%global version_micro 8
%global commitid 778792ff3dd662099865d489e2e4009b94da2dbb
%global serial 38

%define with_zip 1
%bcond_with zip

%{?scl:%scl_package mod_md}
%{!?scl:%global pkg_name %{name}}
%{!?apxs: %{expand: %%define apxs %{_sbindir}/apxs}}
%define scldir /opt/rh/jbcs-httpd24/root

Name:           %{?scl_prefix}mod_md
Version:        2.0.8
Release:        %{serial}%{?dist}
Summary:        Certificate provisioning using ACME for the Apache HTTP Server
License:        ASL 2.0
URL:            https://icing.github.io/mod_md/
Group:          Internet/WWW/Servers
Source0:        %{pkg_name}-%{commitid}.tar.gz
Epoch:          1
BuildRequires:  gcc

BuildRoot: %{_tmppath}/%{name}-%{version}-buildroot

%if "%{?rhel}" >= "7"
# 64 bit only natives on RHEL7
ExcludeArch: i386 i686
%endif

BuildRequires: libtool, patchelf
BuildRequires: %{?scl_prefix}apr-devel
BuildRequires: %{?scl_prefix}apr-util-devel
BuildRequires: %{?scl_prefix}httpd-devel
BuildRequires: %{?scl_prefix}openssl-devel
BuildRequires: %{?scl_prefix}jansson-devel
BuildRequires: %{?scl_prefix}libcurl-devel
BuildRequires: %{?scl_prefix}nghttp2-devel

BuildRequires: zip

BuildRequires: %{?scl_prefix}httpd
BuildRequires: %{?scl_prefix}openssl
BuildRequires: %{?scl_prefix}jansson
BuildRequires: %{?scl_prefix}libcurl
BuildRequires: %{?scl_prefix}nghttp2

Requires: %{?scl_prefix}httpd
Requires: %{?scl_prefix}apr
Requires: %{?scl_prefix}apr-util
Requires: %{?scl_prefix}openssl
Requires: %{?scl_prefix}jansson
Requires: %{?scl_prefix}libcurl
Requires: %{?scl_prefix}nghttp2

# Excludes libnghttp2.so.* from Requires, since the devel package already Requires jbcs-httpd24-nghttp2
%global __requires_exclude ^(libnghttp2[.]so.*)$

%description
This module manages common properties of domains for one or more
virtual hosts. Specifically it can use the ACME protocol to automate
certificate provisioning.  Certificates will be configured for managed
domains and their virtual hosts automatically, including at renewal.

%if %with zip
%package src-zip
Summary:     Container for the source distribution of %{pkg_name}
Group:       Development

%description src-zip
Container for the source distribution of %{pkg_name}.
%endif

%prep
%setup -q -n %{pkg_name}-%{commitid}

# Rewrite release number
sed -i "s;-git;-%{serial};g" src/md_version.h.in

%build
%if %with zip
zip -q -r %{name}-%{version}-src.zip *
%endif

CPPFLAGS="-I%{scldir}/usr/include"
export CPPFLAGS

test -d "%{scldir}/usr/lib64" && \
    LDFLAGS="-L%{scldir}/usr/lib64" || \
    LDFLAGS="-L%{scldir}/usr/lib"

LDFLAGS="$LDFLAGS -Wl,-rpath=%{_libdir}"
# Adding the "-z,now" option in LDFLAGS in order to gain
# full RELRO support
%if "%{?rhel}" >= "7"
LDFLAGS="$LDFLAGS -Wl,-z,now"
%else
LDFLAGS="$LDFLAGS -Wl,-z,relro,-z,now"
%endif
export LDFLAGS

./configure --with-apxs=%{_sbindir}/apxs \
    --with-jansson=%{scldir}/usr \
    --with-openssl=%{scldir}/usr \
    --with-curl=%{scldir}/usr

make %{?_smp_mflags} V=1

%install
%make_install

%if %with zip
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_javadir}/jbossas-fordev
%{__install} %{name}-%{version}-src.zip  ${RPM_BUILD_ROOT}%{_javadir}/jbossas-fordev/%{name}-%{version}-src.zip
%endif

rm -rf %{buildroot}%{scldir}/etc/httpd/share/doc/
%{__install} -d -m 0755 %{buildroot}%{_bindir}

# remove links and rename SO files
rm -f %{buildroot}%{_libdir}/httpd/modules/mod_md.so
mv %{buildroot}%{_libdir}/httpd/modules/mod_md.so.0.0.0 %{buildroot}%{_libdir}/httpd/modules/mod_md.so
mv %{buildroot}%{scldir}/etc/httpd/bin/a2md %{buildroot}%{_bindir}/a2md

# create configuration
mkdir -p %{buildroot}%{_sysconfdir}/httpd/conf.modules.d
echo "LoadModule md_module modules/mod_md.so" > %{buildroot}%{_sysconfdir}/httpd/conf.modules.d/01-md.conf
#JBCS-812
echo "MDStoreDir %{scldir}/var/lib/httpd/md" >> %{buildroot}%{_sysconfdir}/httpd/conf.modules.d/01-md.conf

%files
%doc README.md ChangeLog AUTHORS LICENSE
%config(noreplace) %{_sysconfdir}/httpd/conf.modules.d/01-md.conf
%{_libdir}/httpd/modules/mod_md.so
%{_bindir}/a2md

%if %with zip
%files src-zip
%defattr(0644,root,root,0755)
%{_javadir}/jbossas-fordev/%{name}-%{version}-src.zip
%endif

%changelog
* Mon Sep 27 2021 cpaas-ops <cpaas-ops@redhat.com> - 2.0.8-38
Built by CPaaS

* Thu Sep 16 2021 cpaas-ops <cpaas-ops@redhat.com> - 2.0.8-37
Built by CPaaS

* Fri Jun 11 2021 cpaas-ops <cpaas-ops@redhat.com> - 2.0.8-36
Built by CPaaS

* Wed Jun 02 2021 cpaas-ops <cpaas-ops@redhat.com> - 2.0.8-35
Built by CPaaS

* Thu May 06 2021 cpaas-ops <cpaas-ops@redhat.com> - 2.0.8-34
Built by CPaaS

* Thu Apr 01 2021 cpaas-ops <cpaas-ops@redhat.com> - 2.0.8-33
Built by CPaaS

* Fri Mar 26 2021 cpaas-ops <cpaas-ops@redhat.com> - 2.0.8-32
Built by CPaaS

* Sun Jan 03 2021 cpaas-ops <cpaas-ops@redhat.com> - 2.0.8-31
Built by CPaaS

* Sun Oct 11 2020 cpaas-ops <cpaas-ops@redhat.com> - 2.0.8-30
Built by CPaaS

* Sat Oct 10 2020 cpaas-ops <cpaas-ops@redhat.com> - 2.0.8-29
Built by CPaaS

* Sat Oct 10 2020 cpaas-ops <cpaas-ops@redhat.com> - 2.0.8-28
Built by CPaaS

* Thu Oct 08 2020 cpaas-ops <cpaas-ops@redhat.com> - 2.0.8-27
Built by CPaaS

* Wed Oct 07 2020 Sokratis Zappis <szappis@redhat.com> - 2.0.8-26
- Test

* Tue Oct 06 2020 cpaas-ops <cpaas-ops@redhat.com> - 2.0.8-25
Built by CPaaS

* Tue Dec 17 2019 Dimitris Sartzetakis <dsartzet@redhat.com> - 2.0.8-10
- JBCS 2.4.37-SP1.ER1

* Mon Dec 16 2019 Mladen Turk <mturk@redhat.com> - 1:2.0.8-9
- Rebuild for jbcs with updated commitid

* Tue Dec 10 2019 Dimitris Sartzetakis <dsartzet@redhat.com> - 2.0.8-8
- Creating src-zip rpm

* Wed Dec 04 2019 Mladen Turk <mturk@redhat.com> - 1:2.0.8-6
- Rebuild for jbcs

* Thu Oct 03 2019 Lubos Uhliarik <luhliari@redhat.com> - 1:2.0.8-5
- Resolves: #1747898 - add mod_md package

* Fri Aug 30 2019 Joe Orton <jorton@redhat.com> - 1:2.0.8-4
- require mod_ssl, update package description

* Fri Aug 30 2019 Joe Orton <jorton@redhat.com> - 1:2.0.8-3
- rebuild against 2.4.41

* Thu Jul 25 2019 Fedora Release Engineering <releng@fedoraproject.org> - 1:2.0.8-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_31_Mass_Rebuild

* Fri Jul 12 2019 Joe Orton <jorton@redhat.com> - 1:2.0.8-1
- update to 2.0.8

* Tue Jun 11 2019 Lubos Uhliarik <luhliari@redhat.com> - 2.0.3-1
- Initial import (#1719248).
